/*
 * Basic versioning gathered from the git repository.
 * Automatically generated by ./git_version.sh.
 */

#ifndef GIT_VERSION_H
#define GIT_VERSION_H 1

#include <stdint.h>

/* whether this is a dist tarball or not */
#undef GIT_IS_DIST

/* No errors occured while running git */
#undef GIT_ERRORS

/* git utilities not found */
#define GIT_NOT_FOUND "'git' not found"
#undef GIT_VERSION

/* The following helps debug why we sometimes do not find ".git/":
 * abs_repo_dir="/home/abuild/rpmbuild/BUILD/systemtap-5.0" (should be "/path/to/.git")
 * abs_srcdir="/home/abuild/rpmbuild/BUILD/systemtap-5.0" (absolute top source dir "/path/to")
 * git_repo_dir="" (usually ".git" or "/path/to/.git")
 * PWD="/home/abuild/rpmbuild/BUILD/systemtap-5.0"
 * srcdir="."
 * working_dir="/home/abuild/rpmbuild/BUILD/systemtap-5.0"
 */

/* No git repo found, probably building from dist tarball */
#undef GIT_REPO

/* Define GIT_MESSAGE such that
 *    printf("%s: built from %s", argv[0], GIT_MESSAGE);
 * forms a proper sentence.
 */

#ifdef GIT_DIRTY
# define GIT_DIRTY_MSG "-dirty"
#else /* !GIT_DIRTY */
# define GIT_DIRTY_MSG ""
#endif /* GIT_DIRTY */

#ifdef GIT_ERRORS
# define GIT_ERROR_MSG " with error: " GIT_ERRORS
#else /* !GIT_ERRORS */
# define GIT_ERROR_MSG ""
#endif /* GIT_ERRORS */

#ifdef GIT_IS_DIST
# define GIT_DIST_MSG "dist of "
#else /* !GIT_IS_DIST */
# define GIT_DIST_MSG ""
#endif /* GIT_IS_DIST */

#ifdef GIT_REPO
# ifdef GIT_NOT_FOUND
#  define GIT_MESSAGE GIT_DIST_MSG "git sources without git: " GIT_NOT_FOUND
# else /* !GIT_NOT_FOUND */
#  define GIT_MESSAGE \
       GIT_DIST_MSG \
       "git branch " GIT_BRANCH ", " \
       "url " GIT_REMOTE_URL ", " \
       "commit " GIT_SHAID GIT_DIRTY_MSG \
       GIT_ERROR_MSG
# endif /* GIT_NOT_FOUND */
#else /* !GIT_REPO */
# define GIT_MESSAGE GIT_DIST_MSG "non-git sources" GIT_ERROR_MSG
#endif /* GIT_REPO */

#endif /* GIT_VERSION_H */
